/*
 * Ammo.cpp
 *
 *  Created on: 24 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"Ammo.h"
#include"Level.h"
#include"Player.h"

Ammo::Ammo() : Object("Ammo"), type(WEAPON_NONE), amount(0) // XXX ... fake ammunition, hmm
{

}

Ammo::~Ammo()
{

}

bool Ammo::Init(Vector nPos, WEAPON_TYPE nType, unsigned nAmount)
{
	if(!spr.Load("weapon_ammo.spr") )
		return false;

	pos=nPos;
	pos.z=Z_OBSTACLE;

	type=nType;
	amount=nAmount;
	spr.SetAnimation(GetWeaponName(type) );

	SetLife(-1.0f); // TODO ... I was able to destroy my ammo, GENIUS~!

	maskType=COL_NONE;//COL_RECT;
	mask.x=8;
	mask.y=8;
	mask.w=16;
	mask.h=16;

	return true;
}

void Ammo::Quit()
{
	spr.Free();
}

void Ammo::Update()
{
	Vector v;
	std::list<Object*> objsList;
	maskType=COL_RECT;
	if(Level::CheckCollision(this, mask+pos, &objsList) )
	{
		for(auto itr : objsList)
		{
			if(itr->GetObjectType() == "Player")
			{
				Player *p=dynamic_cast<Player*>(itr);
				if(!p) // just to be sure...
					return;
				if(p->GetAmmo(type)>=p->GetAmmoMax(type))
					break;

				p->AddAmmo(type, amount);
				life=0;
			}
		}
	}
	maskType=COL_NONE;
}

void Ammo::Show()
{
	spr.Show(pos);
}

void Ammo::OnDead()
{
	// XXX Hey, I just met you, and this is crazy, but here's your ammo, so particles maybe? TODO
}
