/*
 * Bullet.cpp
 *
 *  Created on: 24 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"Bullet.h"
#include"Level.h"
#include"Particle.h"
#include<cmath>
#include<cstdlib>

#include<cstdio> // XXX

Bullet::Bullet() : Object("Bullet"), /*parent(NULL),*/ type(WEAPON_PISTOL), speed(0.0f), power(0.0f),
		angle(0.0f), radius(0.0f)
{
	
}

Bullet::~Bullet()
{

}

bool Bullet::Init(Object *p, WEAPON_TYPE nType, Vector nPos, float nAngle, float nSpeed, float nPower)
{
	if(!spr.Load("weapon_bullet.spr") )
		return false;

	parent=p;
	type=nType;
	speed=nSpeed;
	pos=nPos;
	pos.z=Z_BULLET;
	dir=p->GetDirection();//nDir; // unused
	power=nPower;
	radius=power*3.0f; // XXX
	angle=nAngle;

	//SetLife(-1.0f); // TODO
	SetLife(1.0f);

	maskType=COL_RADIAL;

	spr.SetAnimation(GetWeaponName(type) );

	mask.x=14;
	mask.y=14;
	mask.w=4;
	mask.h=4;

	/*switch(nType)
	{
		case WEAPON_PISTOL:
		{
			spr.SetAnimation("pistol");

			mask.x=14;
			mask.y=14;
			mask.w=4;
			mask.h=4;
			break;
		}
		case WEAPON_PPSZ:
		{
			spr.SetAnimation("ppsz");

			mask.x=14;
			mask.y=14;
			mask.w=4;
			mask.h=4;
			break;
		}
		case WEAPON_RCLR:
		{
			spr.SetAnimation("rclr");

			mask.x=14;
			mask.y=14;
			mask.w=4;
			mask.h=4;
			break;
		}
		case WEAPON_CROSSBOW:
		{
			spr.SetAnimation("crossbow");

			mask.x=14;
			mask.y=14;
			mask.w=4;
			mask.h=4;
			break;
		}
		case WEAPON_EGGPLANT:
		{
			spr.SetAnimation("eggplant");

			mask.x=14;
			mask.y=14;
			mask.w=4;
			mask.h=4;
			break;
		}
	}*/

	pos.x-=mask.x+mask.w/2;
	pos.y-=mask.y+mask.h/2;

	/*switch(parent->GetDirection() )
	{
		case DIR_UP:
		{
			spr.SetAngle(270, Vector() );
			break;
		}
		case DIR_DOWN:
		{
			spr.SetAngle(90, Vector() );
			break;
		}
		case DIR_LEFT:
		{
			spr.SetAngle(180, Vector() );
			break;
		}
		case DIR_RIGHT:
		{
			spr.SetAngle(0, Vector() );
			break;
		}
		case DIR_UP_LEFT:
		{
			spr.SetAngle(225, Vector() );
			break;
		}
		case DIR_UP_RIGHT:
		{
			spr.SetAngle(315, Vector() );
			break;
		}
		case DIR_DOWN_LEFT:
		{
			spr.SetAngle(135, Vector() );
			break;
		}
		case DIR_DOWN_RIGHT:
		{
			spr.SetAngle(45, Vector() );
			break;
		}
	}*/

	spr.SetAngle(angle, Vector() );

	return true;
}

void Bullet::Quit()
{
	spr.Free();
}

void Bullet::Update()
{
	Vector vel;//, orgVel;
	vel.x=cos(angle*3.14f/180.0f)*speed;
	vel.y=sin(angle*3.14f/180.0f)*speed;
	//orgVel=vel;

	if(angle > 180.0f)
		angle-=360.0f;
	if(angle < -180.0f)
		angle+=360.0f;

	std::list<Object*> objs;
	//if(!Level::MoveObject(this, vel, true, &objs) )
	if(!Level::MoveObject(this, vel, true, &objs) )
	{
		if(type == WEAPON_CROSSBOW)
		{
			if(objs.empty() )
			{
				unsigned ux=0, uy=0;
				//float angle;

				Rect rA=mask+pos+vel;

				if(rA.x < 0.0f || rA.y < 0.0f || rA.x+rA.w >= Level::levelW*32 || rA.y+rA.h >= Level::levelH*32)
					life=0.0f;
				else
				{

					if(!Level::CanMove( Level::level[int(rA.y)/32*Level::levelW+int(rA.x)/32 ] ) )
					{
						ux=int(rA.x)/32;
						uy=int(rA.y)/32;
					}
					if(!Level::CanMove( Level::level[int(rA.y)/32*Level::levelW+int(rA.x+rA.w-1)/32 ] ) )
					{
						ux=int(rA.x+rA.w-1)/32;
						uy=int(rA.y)/32;
					}
					if(!Level::CanMove( Level::level[int(rA.y+rA.h-1)/32*Level::levelW+int(rA.x)/32 ] ) )
					{
						ux=int(rA.x)/32;
						uy=int(rA.y+rA.h-1)/32;
					}
					if(!Level::CanMove( Level::level[int(rA.y+rA.h-1)/32*Level::levelW+int(rA.x+rA.w-1)/32 ] ) )
					{
						ux=int(rA.x+rA.w-1)/32;
						uy=int(rA.y+rA.h-1)/32;
					}

					rA=mask+pos;
					if(ux*32 <= rA.x && ux*32+32 >= rA.x+rA.w)
					{
						if(uy*32 < rA.y)
							dir=DIR_UP;
						else
							dir=DIR_DOWN;
					}
					else if(uy*32 <= rA.y && uy*32+32 >= rA.y+rA.h)
					{
						if(ux*32 < rA.x)
							dir=DIR_LEFT;
						else
							dir=DIR_RIGHT;
					}
					else
						life=0.0f;

					//printf("Angle: %.1f\n", angle);
					bool ricochet=false;
					switch(dir)
					{
						case DIR_UP:
						{
							if(angle >= -45)
							{
								//angle=-angle;

								float rad=angle*3.14f/180.0f;
								angle=atan2(-sin(rad), cos(rad) )/3.14f*180.0f;
								//vel.x=cos(angle*3.14f/180.0f);//*speed;
								//vel.y=sin(angle*3.14f/180.0f);//*speed;

								ricochet=true;
							}
							else if(angle <= -180+45)
							{
								//angle=-angle;
								float rad=angle*3.14f/180.0f;
								angle=atan2(-sin(rad), cos(rad) )/3.14f*180.0f;
								ricochet=true;
							}

							break;
						}
						case DIR_DOWN:
						{
							if(angle <= 45)
							{
								//angle=-angle;
								float rad=angle*3.14f/180.0f;
								angle=atan2(-sin(rad), cos(rad) )/3.14f*180.0f;
								ricochet=true;
							}
							else if(angle >= 90+45)
							{
								//angle=-angle;
								float rad=angle*3.14f/180.0f;
								angle=atan2(-sin(rad), cos(rad) )/3.14f*180.0f;
								ricochet=true;
							}

							break;
						}
						case DIR_LEFT:
						{
							//if(angle < 0.0f)
							//	angle+=360;

							//printf("--------\n");
							//printf("  Angle: %.1f\n", angle);
							//printf("--------\n");

							if(angle <= 180-45 && angle >= 90.0f)
							//if(angle <= 180-45)
							{
								//angle=-angle;
								float rad=angle*3.14f/180.0f;
								angle=atan2(sin(rad), -cos(rad) )/3.14f*180.0f;
								//printf("  Cos: %f\n", cos(rad) );
								//printf("  AftAngle: %.1f\n", angle);
								//printf("--------\n");
								ricochet=true;
							}
							//if(angle >= 180+45)
							else if(angle >= -180+45 && angle < -90.0f)
							{
								//angle=-angle;
								float rad=angle*3.14f/180.0f;
								angle=atan2(sin(rad), -cos(rad) )/3.14f*180.0f;
								//printf("  Cos: %f\n", cos(rad) );
								//printf("  AftAngle: %.1f\n", angle);
								//printf("--------\n");
								ricochet=true;
							}

							//ricochet=false;

							break;
						}
						case DIR_RIGHT:
						{
							if(angle <= -45)
							{
								//angle=-angle;
								float rad=angle*3.14f/180.0f;
								angle=atan2(sin(rad), -cos(rad) )/3.14f*180.0f;
								ricochet=true;
							}
							else if(angle >= 45)
							{
								//angle=-angle;
								float rad=angle*3.14f/180.0f;
								angle=atan2(sin(rad), -cos(rad) )/3.14f*180.0f;
								ricochet=true;
							}

							break;
						}
						default:
						{
							life=0.0f;
							break;
						}
					}

					if(!ricochet)
						life=0.0f;
					else
					{
						if(angle > 180.0f)
							angle-=360.0f;
						if(angle < -180.0f)
							angle+=360.0f;
						spr.SetAngle(angle, spr.GetAngleSpot() );

						vel.x=cos(angle*3.14f/180.0f);//*speed;
						vel.y=sin(angle*3.14f/180.0f);//*speed;
						//pos-=vel;
						//pos-=orgVel*10;
						pos+=vel*2.0f;
						//if(!Level::MoveObject(this, vel, true, NULL) )
						//	life=0.0f;
					}

					//printf("  Ricochet: %d, Angle: %.1f\n", ricochet, angle);

					//printf("UXY: %dx%d\n", ux, uy);
					//life=0.0f;
					//printf("Rect: %.1fx%.1f, %.1fx%.1f\n %dx%d\n", rA.x, rA.y, rA.w, rA.h, ux*32, uy*32);
					//printf("  DIR: %s\n", GetDirectionName(dir).c_str() );
				}
			}
			else
				life=0.0f;
		}
		else
			life=0.0f;
	}
	objs.clear();
	/*{
		if(type == WEAPON_RCLR)
		{
			//float radius=power*3.0f;

			objs.clear();
			Level::GetObjects(this, pos+Vector(mask.x+mask.w/2.0f, mask.y+mask.h/2.0f), radius, objs);
			if(objs.empty() )
				printf("WTF~!?\n");
			for(auto itr : objs)
			{
				Vector bA=pos+Vector(mask.x+mask.w/2.0f, mask.y+mask.h/2.0f);
				Rect rB=itr->GetRect();
				Vector bB=itr->GetPosition()+Vector(rB.x+rB.w/2.0f, rB.y+rB.h/2.0f);
				float dx=bB.x-bA.x;
				float dy=bB.y-bA.y;
				float dist=sqrt(dx*dx+dy*dy);

				float tmp;
				{
					bB=itr->GetPosition()+Vector(rB.x, rB.y+rB.h/2.0f);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}
				{
					bB=itr->GetPosition()+Vector(rB.x+rB.w, rB.y+rB.h/2.0f);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}
				{
					bB=itr->GetPosition()+Vector(rB.x+rB.w/2, rB.y);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}
				{
					bB=itr->GetPosition()+Vector(rB.x+rB.w/2, rB.y+rB.h);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}

				printf("Obj: %s, Kill: %.1f\n", itr->GetObjectType().c_str(), power-(dist/radius)*power);

				//itr->Kill(power-dist);
				itr->Kill(power-(dist/radius)*power);
			}
			life=0;
		}
		else
		{
			// Destroy~!
			if(objs.empty() )
			{
				// Wall~!
				life=0;
				//printf("  Vel: %.1fx%.1f\n", vel.x, vel.y);
			}
			else
			{
				// Objs
				for(auto itr : objs)
				{
					if(itr != parent)
						itr->Kill(power);
				}
				life=0;
			}
		}
	}*/

	//printf("Life: %.1f\n---------\n", life);
}

void Bullet::Show()
{
	//printf("Bullet Z: %.1f\n", pos.z);
	spr.Show(pos);
}

void Bullet::OnDead() // YES, ROCKET (RCLR) CHAIN REACTION~!
{
	//printf("Belt zabity~!\n");

	Vector vel;
	vel.x=cos(angle*3.14f/180.0f)*speed;
	vel.y=sin(angle*3.14f/180.0f)*speed;

	std::list<Object*> objs;
	if(!Level::MoveObject(this, vel, true, &objs) ) // TODO XXX or just GetObjects with radius=1,2,3?
	//Level::GetObjects(this, pos, (mask.w/2.0f+mask.h/2.0f)/2.0f, objs);
	{
		if(type == WEAPON_RCLR)
		{
			//float radius=power*3.0f;

			objs.clear();
			Level::GetObjects(this, pos+Vector(mask.x+mask.w/2.0f, mask.y+mask.h/2.0f), radius, objs);
			//if(objs.empty() )
				//printf("WTF~!?\n");
			for(auto itr : objs)
			{
				Vector bA=pos+Vector(mask.x+mask.w/2.0f, mask.y+mask.h/2.0f);
				Rect rB=itr->GetRect();
				Vector bB=itr->GetPosition()+Vector(rB.x+rB.w/2.0f, rB.y+rB.h/2.0f);
				float dx=bB.x-bA.x;
				float dy=bB.y-bA.y;
				float dist=sqrt(dx*dx+dy*dy);

				float tmp;
				{
					bB=itr->GetPosition()+Vector(rB.x, rB.y+rB.h/2.0f);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}
				{
					bB=itr->GetPosition()+Vector(rB.x+rB.w, rB.y+rB.h/2.0f);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}
				{
					bB=itr->GetPosition()+Vector(rB.x+rB.w/2, rB.y);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}
				{
					bB=itr->GetPosition()+Vector(rB.x+rB.w/2, rB.y+rB.h);
					dx=bB.x-pos.x;
					dy=bB.y-pos.y;
					tmp=sqrt(dx*dx+dy*dy);
					if(tmp < dist)
						dist=tmp;
				}

				//printf("Obj: %s, Kill: %.1f\n", itr->GetObjectType().c_str(), power-(dist/radius)*power);

				//itr->Kill(power-dist);
				itr->Kill(power-(dist/radius)*power);
			}
			life=0;
		}
		else
		{
			// Destroy~!
			if(objs.empty() )
			{
				// Wall~!
				life=0;
				//printf("  Vel: %.1fx%.1f\n", vel.x, vel.y);
			}
			else
			{
				// Objs
				for(auto itr : objs)
				{
					if(itr != parent)
						itr->Kill(power);
				}
				life=0;
			}
		}
	}

	if(type == WEAPON_RCLR)
	{
		// TODO particles~!
		for(unsigned a=0; a < power*20; ++a)
		{
			Particle *p=new Particle;
			//if(!p->Init(pos+Vector(mask.x+mask.w/2-1, mask.y+mask.h/2-1), (rand()%int(speed*20) )/20.0f+1.0f, a, radius, Color(1.0f, 0.0f, 0.0f, 1.0f), Color(1.0f, 1.0f, 0.0f, 0.0f) ) )
			if(!p->Init(pos+Vector(mask.x+mask.w/2-1, mask.y+mask.h/2-1), (rand()%int(speed*20) )/20.0f+1.0f, rand()%360, radius, Color(1.0f, 0.0f, 0.0f, 1.0f), Color(1.0f, 1.0f, 0.0f, 0.0f) ) )
				printf("Can't create particle!\n");
			Level::AddObject(p);
		}
	}
}
