#pragma once
/*
 * Cutscene.h
 *
 * Created on: 23 sie 2013
 *    Project: LDJam27
 *     Author: crm
 */

#include <vector>
 
#include "base.h"
#include "Texture.h"

class Cutscene
{
	private:
		enum Direction
		{
			LEFT,
			RIGHT,
			UP,
			DOWN
		};
	
		struct Scene
		{
			String path;		// Sciezka do pliku
			Texture tex;		// Tekstura, ladowana kiedy scena jest aktywna
			Direction dir_in;	// Kierunek lotu wejsciowy
			Direction dir_out;	// Kierunek lotu wyjsciowy
			float delay;		// <=0 -> przejscie do nastepnego po kliknieciu
			float anim_spd;		// Szybkosc wykonania animacji, 0.5s lub 'delay', jesli 'delay' jest mniejszy
			
			float pct;			// Procent wykonania animacji
		};
		
		std::vector<Scene *> scenes;
		unsigned scene;
		float delay;
		bool finished, screenFilled;
		
		void Next();
		
	public:
		Cutscene(): scene(0u), delay(0.0f), finished(true), screenFilled(false) {}
		~Cutscene() {Free();}
		
		bool Load(String path);
		void Free();
		
		void Update();
		void Show();
		
		void Skip();// {scene=scenes.size();}
		
		//bool IsFinished() const {return scenes.back()->pct>=1.0f;}	// Ostatnia scena zostala odtworzona do konca (wyjechala z ekranu)
		bool IsFinished() const {return finished;}

		bool IsScreenFilled();
};
