/*
 * Event.cpp
 *
 *  Created on: 26 mar 2013
 *      Author: cybek
 */

#include"Event.h"

#include<SDL/SDL.h>
#include<set>

namespace
{
	std::set<Event*> regEvents;
}

Event::Event() : mask(0)
{
	regEvents.insert(this);
}

Event::~Event()
{
	regEvents.erase(this);
}

void Event::Register(unsigned mask)
{
	this->mask|=mask;
}

void Event::Unregister(unsigned mask)
{
	this->mask&=~mask;
}

void Event::Update()
{
	// Clear last events list
	for(auto itr : regEvents)
		itr->events.clear();

	SDL_Event e;
	while(SDL_PollEvent(&e) )
		Add(e);
}

void Event::Add(SDL_Event e)
{
	for(auto itr=regEvents.begin(); itr != regEvents.end(); ++itr)
	{
		Event *ev=*itr;
		if(SDL_EVENTMASK(e.type) & ev->mask)
			ev->events.push_back(e);
	}
}
