/*
 * Object.cpp
 *
 *  Created on: 24 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"Object.h"
#include"Video.h"
#include<cmath>

#include<cstdio>

Object::Object(String objType) : _objType(objType), parent(NULL), dir(DIR_UP), maskType(COL_NONE), life(1.0f), lifeMax(1.0f)
{
	//printf("Obj: %p\n", this);
}

Object::~Object()
{

}

void Object::SetPosition(Vector nPos)
{
	pos=nPos;
}

Vector Object::GetPosition()
{
	return pos;
}

Vector Object::GetCenter()
{
	return Vector(pos.x+mask.x+mask.w/2.0f, pos.y+mask.y+mask.h/2.0f);
}

Object *Object::GetParent()
{
	return parent;
}

Rect Object::GetRect()
{
	return mask;
}

COLLISION Object::GetMaskType()
{
	return maskType;
}

float Object::GetDistance(Object *ob)
{
	Vector posB=ob->GetPosition();

	float dx=pos.x-posB.x;
	float dy=pos.y-posB.y;

	return sqrt(dx*dx+dy*dy);
}

Direction Object::GetDirection()
{
	return dir;
}

void Object::SetLife(float nLife)
{
	lifeMax=life=nLife;
}

float Object::GetLife()
{
	return life;
}

float Object::GetLifeMax()
{
	return lifeMax;
}

void Object::ShowLife()
{
	if(life == -1.0f)
		return;
	if(_objType == "Bullet")
		return;
	if(_objType == "Particle")
		return;

	Video::DrawRect(Rect(pos.x+mask.x, pos.y-8, mask.w, 4), Color(1.0f, 0.0f, 0.0f, 1.0f) );
	Video::DrawRect(Rect(pos.x+mask.x, pos.y-8, mask.w*life/lifeMax, 4), Color(0.0f, 1.0f, 0.0f, 1.0f) );
}

void Object::Kill(float power)
{
	if(life < 0.0f)
		return;

	life-=power;
	if(life < 0.0f)
		life=0.0f;
}

void Object::Heal(float power)
{
	life+=power;
	if(life > lifeMax)
		life=lifeMax;
}
