#pragma once
/*
 * Object.h
 *
 *  Created on: 24 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"base.h"
#include"Sprite.h"

enum Direction{DIR_LEFT=0, DIR_RIGHT=1, DIR_UP=2, DIR_DOWN=3, DIR_UP_LEFT=4, DIR_UP_RIGHT=5, DIR_DOWN_LEFT=6, DIR_DOWN_RIGHT=7};

enum ZPOS{Z_BACKGROUND=-12, Z_LEVEL=-10, Z_OBSTACLE=-8, Z_LASER=-7, Z_BULLET=-6, Z_WEAPON=-5, Z_ENEMY=-4, Z_PLAYER=-2, Z_PARTICLE=-1};

inline String GetDirectionName(Direction d)
{
	switch(d)
	{
		case DIR_LEFT:
			return "left";
		case DIR_RIGHT:
			return "right";
		case DIR_UP:
			return "up";
		case DIR_DOWN:
			return "down";
		case DIR_UP_LEFT:
			return "up_left";
		case DIR_UP_RIGHT:
			return "up_right";
		case DIR_DOWN_LEFT:
			return "down_left";
		case DIR_DOWN_RIGHT:
			return "down_right";
	}

	return "";
}

inline Direction GetDirection(String n)
{
	if(n == "left")
		return DIR_LEFT;
	if(n == "right")
		return DIR_RIGHT;
	if(n == "up")
		return DIR_UP;
	if(n == "down")
		return DIR_DOWN;
	if(n == "up_left")
		return DIR_UP_LEFT;
	if(n == "up_right")
		return DIR_UP_RIGHT;
	if(n == "down_left")
		return DIR_DOWN_LEFT;
	if(n == "down_right")
		return DIR_DOWN_RIGHT;

	return DIR_UP;
}

inline Direction FindDirection(float angle)
{
	if(angle < 23 && angle > -23)
		return DIR_RIGHT;
	else if(angle < 68 && angle >= 23)
		return DIR_DOWN_RIGHT;
	else if(angle < 113 && angle >= 68)
		return DIR_DOWN;
	else if(angle < 158 && angle >= 113)
		return DIR_DOWN_LEFT;
	else if(angle < -158 || angle >= 158)
		return DIR_LEFT;
	else if(angle < -113 && angle >= -158)
		return DIR_UP_LEFT;
	else if(angle < -68 && angle >= -113)
		return DIR_UP;
	else if(angle < -23 && angle >= -68)
		return DIR_UP_RIGHT;

	return DIR_UP;
}

// GEH... class COLLISION, with ELEMENTS COL_*, but instance is named "maskType"... NEVER AGAIN~!
enum COLLISION{COL_NONE=0, COL_RECT=1, COL_RADIAL=2};

class Object
{
	protected:
		String _objType;
		Object *parent;
		Vector pos;//, vel;
		Sprite spr;
		Direction dir;
		Rect mask;
		COLLISION maskType;

		float life, lifeMax;

	public:
		Object(String objType);
		virtual ~Object();

		virtual void Quit()=0;

		void SetPosition(Vector nPos);
		Vector GetPosition();
		Vector GetCenter();

		Object *GetParent();

		Rect GetRect();
		COLLISION GetMaskType();

		float GetDistance(Object *ob);

		Direction GetDirection();

		void SetLife(float nLife);
		float GetLife();
		float GetLifeMax();

		virtual void Update()=0;
		virtual void Show()=0;
		virtual void OnDead()=0;
		void ShowLife();

		void Kill(float power);
		void Heal(float power);

		String GetObjectType() { return _objType; }
};
