/*
 * Particle.cpp
 *
 *  Created on: 25 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"Particle.h"
#include"Level.h"
#include<cmath>
#include<cstdlib>
#include<cstdio>

Particle::Particle() : Object("Particle"), speed(0.0f), angle(0.0f)
{
	
}

Particle::~Particle()
{

}

bool Particle::Init(Vector nPos, float nSpeed, float nAngle, float nLife, Color nCol1, Color nCol2)
{
	if(!spr.Load("particle.spr") )
		return false;

	char tmp[64];
	sprintf(tmp, "%d", rand()%spr.GetAnimationsCount() );
	spr.SetAnimation(tmp);

	pos=nPos;
	pos.z=Z_PARTICLE;

	speed=nSpeed;
	angle=nAngle;
	col1=nCol1;
	col2=nCol2;
	//col2.a=0.0f; // protection...?
	SetLife(nLife);

	maskType=COL_NONE;
	mask.x=0.0f;
	mask.y=0.0f;
	mask.w=0.0f;
	mask.h=0.0f;

	return true;
}

void Particle::Quit()
{
	spr.Free();
}

void Particle::Update()
{
	Vector vel;
	vel.x=cos(angle*3.14f/180.0f)*speed;
	vel.y=sin(angle*3.14f/180.0f)*speed;
	//life-=sqrt(vel.x*vel.x+vel.y*vel.y);
	Kill(sqrt(vel.x*vel.x+vel.y*vel.y) );

	//Level::MoveObject(this, vel, false, NULL);
	if(!Level::CheckCollisionOnlyLevel(this, mask+pos+vel) )
		pos+=vel;
	else
		life=0.0f;

	//spr.SetColor(Color(1.0f, 1.0f, 1.0f, life/lifeMax) );
	spr.SetColor(col1+(col2-col1)*( (lifeMax-life)/lifeMax) );
}

void Particle::Show()
{
	spr.Show(pos);
}

void Particle::OnDead()
{
	// TODO... CREATE PARTICLE AFTER KILLING PARTICLE, HELL YEAH~!
}
