#pragma once
/*
 * Sprite.h
 *
 *  Created on: 23 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"base.h"
#include"Texture.h"

class SpriteData;
class Sprite
{
	protected:
		String path;
		SpriteData *data;
		unsigned curFrame, curAnim;
		unsigned timer;
		float angle;
		Vector angleSpot;
		Color color;

	public:
		Sprite();
		~Sprite();

		bool Load(String path);
		void Free();

		void Update();
		void Show(Vector dst);

		void SetAnimation(String name);
		String GetAnimation();
		unsigned GetAnimationsCount();

		void SetFrame(unsigned id);
		unsigned GetFrame();

		void SetAngle(float nAngle, Vector nAngleSpot);
		float GetAngle();
		Vector GetAngleSpot();

		void SetColor(Color nColor);

		Rect GetMask(); // OBSTACLE ONLY~!
};
