/*
 * Vector.cpp
 *
 *  Created on: 23 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"Vector.h"

Vector::Vector() : x(0.0f), y(0.0f), z(0.0f)
{

}

Vector::Vector(float x, float y, float z) : x(x), y(y), z(z)
{

}

Vector::Vector(const Vector &v) : x(v.x), y(v.y), z(v.z)
{

}

Vector Vector::operator+(const Vector &v)
{
	return Vector(x+v.x, y+v.y, z);
}

Vector &Vector::operator+=(const Vector &v)
{
	x+=v.x;
	y+=v.y;
	return *this;
}

Vector Vector::operator-(const Vector &v)
{
	return Vector(x-v.x, y-v.y, z);
}

Vector &Vector::operator-=(const Vector &v)
{
	x-=v.x;
	y-=v.y;
	return *this;
}

Vector Vector::operator*(float v)
{
	return Vector(x*v, y*v);
}

Vector &Vector::operator*=(float v)
{
	x*=v;
	y*=v;
	return *this;
}

Vector Vector::operator/(float v)
{
	return Vector(x/v, y/v);
}

Vector &Vector::operator/=(float v)
{
	x/=v;
	y/=v;
	return *this;
}
