/*
 * Weapon.cpp
 *
 *  Created on: 24 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"Weapon.h"
#include"Bullet.h"
#include"Level.h"
#include"Video.h"
#include"Input.h"
#include"main.h"
#include<cmath>

//#include"Sound.h"

#include"Player.h"

//class Player;

//#include<cstdio> // XXX

namespace WeaponCfg
{
//#include"weapon.cfg"
	// PISTOL
	// speed, power, maxAngle, delay, begAmmo, maxAmmo

	//							speed	power	maxAngle	delay	begAmmo	maxAmmo
	const float pistol[]=		{10, 	1, 		80, 		0, 		50, 	100};
	const float ppsz[]=			{12, 	2, 		25, 		75, 	100,	200};
	const float rclr[]=			{5, 	20, 	45, 		0, 		4, 		12};
	const float crossbow[]=		{8, 	30, 	45, 		0, 		8,		20};
	const float eggplant[]=		{11, 	1, 		90, 		20,		1000, 	1000};
}

Weapon::Weapon() : Object("Weapon"), type(WEAPON_PISTOL), /*parent(NULL),*/ bulletSpeed(0.0f),
		bulletPower(0.0f), maxAngle(0.0f), fireDelay(0), fireTimer(0), ammo(0), ammoMax(0),
		weaponWave(0.0f)
{

}

Weapon::~Weapon()
{

}

bool Weapon::Init(Object *p, WEAPON_TYPE nType, Vector nRotSpot)//, float nBulletSpeed, float nBulletPower, float nMaxAngle, unsigned nFireDelay)
{
	type=nType;
	if(type == WEAPON_NONE)
		return true;

	if(!spr.Load("weapon.spr") )
		return false;

	parent=p;

	//bulletSpeed=nBulletSpeed;
	//bulletPower=nBulletPower;
	//maxAngle=nMaxAngle;
	//fireDelay=nFireDelay;
	fireTimer=GetTicks();

	const float *dataPtr=NULL;

	//spr.SetAnimation("pistol");
	spr.SetAnimation(GetWeaponName(type) );
	//rotSpot=Vector(13, 6); // TODO
	rotSpot=nRotSpot;

	switch(type)
	{
		case WEAPON_PISTOL:
		{
			//spr.SetAnimation("pistol");
			//rotSpot=Vector(13, 6); // TODO
			dataPtr=WeaponCfg::pistol;

			/*bulletSpeed=WeaponCfg::pistol[0];
			bulletPower=WeaponCfg::pistol[1];
			maxAngle=WeaponCfg::pistol[2];
			fireDelay=WeaponCfg::pistol[3];*/

			break;
		}
		case WEAPON_PPSZ:
		{
			//spr.SetAnimation("ppsz");
			//rotSpot=Vector(13, 6); // TODO
			dataPtr=WeaponCfg::ppsz;

			/*bulletSpeed=WeaponCfg::ppsz[0];
			bulletPower=WeaponCfg::ppsz[1];
			maxAngle=WeaponCfg::ppsz[2];
			fireDelay=WeaponCfg::ppsz[3];*/

			break;
		}
		case WEAPON_RCLR:
		{
			//spr.SetAnimation("rclr");
			//rotSpot=Vector(13, 6); // TODO
			dataPtr=WeaponCfg::rclr;

			/*bulletSpeed=WeaponCfg::rclr[0];
			bulletPower=WeaponCfg::rclr[1];
			maxAngle=WeaponCfg::rclr[2];
			fireDelay=WeaponCfg::rclr[3];*/

			break;
		}
		case WEAPON_CROSSBOW:
		{
			//spr.SetAnimation("crossbow");
			//rotSpot=Vector(13, 6); // TODO
			dataPtr=WeaponCfg::crossbow;

			/*bulletSpeed=WeaponCfg::crossbow[0];
			bulletPower=WeaponCfg::crossbow[1];
			maxAngle=WeaponCfg::crossbow[2];
			fireDelay=WeaponCfg::crossbow[3];*/

			break;
		}
		case WEAPON_EGGPLANT:
		{
			//spr.SetAnimation("eggplant");
			//rotSpot=Vector(13, 6); // TODO
			dataPtr=WeaponCfg::eggplant;

			/*bulletSpeed=WeaponCfg::eggplant[0];
			bulletPower=WeaponCfg::eggplant[1];
			maxAngle=WeaponCfg::eggplant[2];
			fireDelay=WeaponCfg::eggplant[3];*/

			break;
		}
		default:
		{
			return false;
		}
	}

	bulletSpeed=dataPtr[0];
	bulletPower=dataPtr[1];
	maxAngle=dataPtr[2];
	fireDelay=dataPtr[3];
	ammo=dataPtr[4];
	ammoMax=dataPtr[5];

	weaponWave=0.0f;

	return true;
}

void Weapon::Quit()
{
	if(type == WEAPON_NONE)
		return;

	spr.Free();
	//printf("Testing..\n");
}

void Weapon::Update()
{
	if(type == WEAPON_NONE)
		return;

	//pos=parent->GetPosition();//+Vector(parent->GetRect().x+parent->GetRect().w/2-rect.x-rect.w/2, parent->GetRect().y+parent->GetRect().h/2-rect.y-rect.h/2);
	pos=parent->GetCenter()-Vector(spr.GetMask().x+spr.GetMask().w/2.0f, spr.GetMask().y+spr.GetMask().h/2.0f);//-rotSpot;
	pos.z=Z_WEAPON;
	dir=parent->GetDirection();

	//dir=DIR_RIGHT;
	switch(dir)
	{
		case DIR_UP:
		{
			spr.SetAngle(270, rotSpot);
			break;
		}
		case DIR_DOWN:
		{
			spr.SetAngle(90, rotSpot);
			break;
		}
		case DIR_LEFT:
		{
			spr.SetAngle(180, rotSpot);
			break;
		}
		case DIR_RIGHT:
		{
			spr.SetAngle(0, rotSpot);
			break;
		}
		case DIR_UP_LEFT:
		{
			spr.SetAngle(225, rotSpot);
			break;
		}
		case DIR_UP_RIGHT:
		{
			spr.SetAngle(315, rotSpot);
			break;
		}
		case DIR_DOWN_LEFT:
		{
			spr.SetAngle(135, rotSpot);
			break;
		}
		case DIR_DOWN_RIGHT:
		{
			spr.SetAngle(45, rotSpot);
			break;
		}
	}

	//if(dynamic_cast<Player*>(parent) ) // XXX ?
	if(parent->GetObjectType() == "Player")
	{
		Vector hotSpot;
		//Size wnd=Video::GetSize();
		float rad=spr.GetAngle()*3.14f/180.0f;
		hotSpot.x=rotSpot.x*cos(rad)-rotSpot.y*sin(rad)+parent->GetRect().x+parent->GetRect().w/2;
		hotSpot.y=rotSpot.x*sin(rad)+rotSpot.y*cos(rad)+parent->GetRect().y+parent->GetRect().h/2;
		hotSpot+=parent->GetPosition();

		// TODO SAM TIN WONG~! XXX TODO
		float defAngle=spr.GetAngle();
		int mx, my;
		Mouse::GetPosition(mx, my);
		//float mRad=atan2( (my+Video::GetCamera().y)-(pos.y+rect.y+rect.h/2+rotSpot.y), (mx+Video::GetCamera().x)-(pos.x+rect.x+rect.w/2+rotSpot.x) );
		float mRad=atan2( (my+Video::GetCamera().y)-(hotSpot.y), (mx+Video::GetCamera().x)-(hotSpot.x) );
		// XXX float mRad=atan2( (my+Video::GetCamera().y-wnd.h/2.0f)-(hotSpot.y), (mx+Video::GetCamera().x-wnd.w/2.0f)-(hotSpot.x) );
		// TODO float mRad=atan2( (my+Video::GetCamera().y)-(parent->GetPosition().y+parent->GetRect().y+parent->GetRect().h/2), (mx+Video::GetCamera().x)-(parent->GetPosition().x+parent->GetRect().x+parent->GetRect().w/2) );
		mRad-=defAngle*3.14f/180.0f;
		if(mRad < -3.14f)
			mRad+=3.14f*2.0f;
		if(mRad > 3.14f)
			mRad-=3.14f*2.0f;

		float pAngle=mRad/3.14f*180.0f;
		if(pAngle > maxAngle)
		{
			pAngle=maxAngle;
			//Level::cursorInSight=false;
			cursorColor=Color(1.0f, 0.0f, 0.0f, 1.0f);
		}
		else if(pAngle < -maxAngle)
		{
			pAngle=-maxAngle;
			//Level::cursorInSight=false;
			cursorColor=Color(1.0f, 0.0f, 0.0f, 1.0f);
		}
		else
			//Level::cursorInSight=true;
			cursorColor=Color(0.0f, 1.0f, 0.0f, 1.0f);
		pAngle+=defAngle;
		spr.SetAngle(pAngle, spr.GetAngleSpot() );
	}
}

void Weapon::Show()
{
	if(type == WEAPON_NONE)
		return;

	//if(dynamic_cast<Player*>(parent) ) // XXX ?
	if(parent->GetObjectType() == "Player")
	{
		/*
		 * Draw weapon laser
		 */
		Vector v1, v2;
		v1.z=Z_LASER;
		v2.z=Z_LASER;
		float rad=spr.GetAngle()*3.14f/180.0f;
		v1.x=rotSpot.x*cos(rad)-rotSpot.y*sin(rad)+parent->GetRect().x+parent->GetRect().w/2;
		v1.y=rotSpot.x*sin(rad)+rotSpot.y*cos(rad)+parent->GetRect().y+parent->GetRect().h/2;
		v1+=parent->GetPosition();
		Size wnd=Video::GetSize();

		/*
		 * TEST, check max len~!
		 */
		float lX=v1.x+cos(rad)*3, lY=v1.y+sin(rad)*3;
		std::list<Object*> beamObjs;
		//printf("--Start: %d--\n", GetTicks() ); // XXX sam tin wong? freeze if no break inside for each?
		//while(lX < v1.x+wnd.w && lY < v1.y+wnd.h)
		while(abs(lX-v1.x) < wnd.w && abs(lY-v1.y) < wnd.h)
		{
			if(Level::CheckCollision(this, Rect(lX, lY, 1, 1), &beamObjs) )
			{
				if(Level::CheckCollisionOnlyLevel(this, Rect(lX, lY, 1, 1) ) )
				{
					beamObjs.clear();
					break;
				}

				//printf("Objs: %d\n", beamObjs.size() );
				bool finish=false;
				//int a=0;
				for(auto itr : beamObjs)
				{
					//printf("    Iter: %d\n", a++);
					if(itr->GetObjectType() != "Bullet")
					{
						finish=true;
						break;
					}
				}
				beamObjs.clear();
				if(finish)
					break;
			}
			lX+=cos(rad);
			lY+=sin(rad);
		}

		float lDX=lX-v1.x, lDY=lY-v1.y;
		float length=sqrt(lDX*lDX+lDY*lDY);
		v2.x=v1.x+length*cos(rad);
		v2.y=v1.y+length*sin(rad);
		Video::DrawLine(v1, v2, 1, Color(1.0f, 0.0f, 0.0f, 0.5f) );//fabs(sin(GetTicks()/800.0f) )/2.0f+0.5f) );
	}

	spr.Show(pos);
}

bool Weapon::Fire()
{
	if(fireDelay > 0 && GetTicks() < fireTimer+fireDelay)
		return false;
	if(ammo == 0)
	{
		//printf("No ammo...\n");
		return false;
	}
	ammo--;

	Vector hotSpot;
	float rad=spr.GetAngle()*3.14f/180.0f;
	hotSpot.x=rotSpot.x*cos(rad)-rotSpot.y*sin(rad)+parent->GetRect().x+parent->GetRect().w/2;
	hotSpot.y=rotSpot.x*sin(rad)+rotSpot.y*cos(rad)+parent->GetRect().y+parent->GetRect().h/2;
	hotSpot+=parent->GetPosition();

	Bullet *b=new Bullet;
	if(!b->Init(parent, type, hotSpot/*+parent->GetPosition()*/, spr.GetAngle()/*dir*/, bulletSpeed, bulletPower) )
		return false;
	//printf("Bullet name: %s\n", b->GetObjectType().c_str() );
	//printf("  %p, parent: %p\n", b, parent);

	/*if(!Level::CheckCollision(b, b->GetRect()+b->GetPosition(), NULL) )
	{
		printf("Added!\n");
		Level::AddObject(b);
	}*/
	Level::AddObject(b);
	/*else
	{
		printf("Collision~!\n");
		b->Quit();
		delete b;
		return false;
	}*/

	//Sound::sound(GetWeaponName(type)+".wav");
	//Sound::sound("data/pistol.ogg");

	fireTimer=GetTicks();
	return true;
}

void Weapon::Wave(float pct)
{
	weaponWave+=delta/1.0f;

	spr.SetAngle(spr.GetAngle()+sin(weaponWave*2.0f*M_PI)*maxAngle*pct, spr.GetAngleSpot());
}

void Weapon::SetAmmo(unsigned amount)
{
	ammo=amount;
}

void Weapon::AddAmmo(unsigned amount)
{
	ammo+=amount;
	if(ammo > ammoMax)
		ammo=ammoMax;
}

unsigned Weapon::GetAmmo()
{
	return ammo;
}

unsigned Weapon::GetAmmoMax()
{
	return ammoMax;
}

unsigned Weapon::GetFireDelay()
{
	return fireDelay;
}
