#pragma once
/*
 * Weapon.h
 *
 *  Created on: 24 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"Object.h"

enum WEAPON_TYPE{WEAPON_NONE=-1, WEAPON_PISTOL=0, WEAPON_PPSZ=1, WEAPON_RCLR=2, WEAPON_CROSSBOW=3,
	WEAPON_EGGPLANT=4, WEAPON_COUNT};

inline WEAPON_TYPE GetWeaponType(String n)
{
	if(n == "pistol")
		return WEAPON_PISTOL;
	else if(n == "ppsz")
		return WEAPON_PPSZ;
	else if(n == "rclr")
		return WEAPON_RCLR;
	else if(n == "crossbow")
		return WEAPON_CROSSBOW;
	else if(n == "eggplant")
		return WEAPON_EGGPLANT;

	return WEAPON_NONE;
}

inline String GetWeaponName(WEAPON_TYPE t)
{
	if(t == WEAPON_PISTOL)
		return "pistol";
	else if(t == WEAPON_PPSZ)
		return "ppsz";
	else if(t == WEAPON_RCLR)
		return "rclr";
	else if(t == WEAPON_CROSSBOW)
		return "crossbow";
	else if(t == WEAPON_EGGPLANT)
		return "eggplant";
	return "";
}

class Weapon : public Object
{
	protected:
		WEAPON_TYPE type;
		//Object *parent;
		Vector rotSpot;
		float bulletSpeed, bulletPower, maxAngle;
		unsigned fireDelay, fireTimer, ammo, ammoMax;

		float weaponWave;		// Machanie bronia na boki

	public:
		Weapon();
		~Weapon();

		bool Init(Object *p, WEAPON_TYPE nType, Vector nRotSpot);//, float nBulletSpeed, float nBulletPower, float nMaxAngle, unsigned nFireDelay);
		void Quit();

		void Update();
		void Show();
		void OnDead() {} // NEVER HAPPEN, REALLY~! ONLY IF MEGA-ULTRA-HYPER BUG APPEARED~!

		bool Fire();
		void Wave(float percent);

		void SetAmmo(unsigned amount);
		void AddAmmo(unsigned amount);
		unsigned GetAmmo();
		unsigned GetAmmoMax();
		unsigned GetFireDelay();
};
