/*
 * main.cpp
 *
 *  Created on: 23 sie 2013
 *     Project: LDJam27
 *      Author: cybek
 */

#include"main.h"
#include"Video.h"
#include"Event.h"
#include"Input.h"
#include"Level.h"
#include"Texture.h"
//#include"Sound.h"
#include<ctime>
#include<cstdlib>

MAIN_STATE mainState=STATE_MAIN_MENU;
Color cursorColor;

/*
 * BABYMETAL~!
 */

int main()
{
	setbuf(stdout, NULL);
	srand(time(NULL) );

	if(!Video::Init(Size(800, 600), "The Pomidor chronicles") )
		return 1;
	//if(!Sound::init(64) )
	//	return 1;

	//Sound::music("data/pistol.wav", 1.0f);

	Event event;
	event.Register(SDL_QUITMASK);
	event.Register(SDL_KEYDOWNMASK);
	event.Register(SDL_MOUSEBUTTONDOWNMASK);

	Texture cursor;
	if(!cursor.Load("cursor.png") )
		return 1;

	//if(!Level::Init() )
	//	return 1;
	//if(!Level::Load("level1") )
	//	return 1;

	Texture title;
	if(!title.Load("title.png") )
		return 1;

	Texture help;
	if(!help.Load("help.png") )
		return 1;

	Rect startGame=Rect(282, 362, 250, 182);
	Rect exitGame=Rect(329, 544, 133, 48);
	Rect helpGame=Rect(525, 359, 254, 235);
	Rect helpGame2=Rect(15, 336, 269, 154);

	Video::SetCursor(Vector(startGame.x+startGame.w/2, startGame.y+startGame.h/2) );

	bool quit=false;
	while(!quit)
	{
		Event::Update();
		for(auto e : event)
		{
			switch(e.type)
			{
				case SDL_QUIT:
				{
					quit=true;
					break;
				}
				case SDL_KEYDOWN:
				{
					if(e.key.keysym.sym == SDLK_F4 && (e.key.keysym.mod & KMOD_LALT) )
						quit=true;
					else if(e.key.keysym.sym == SDLK_F2)
					{
						if(mainState == STATE_MAIN_GAME)
						{
							//Level::Load("level1");
							Level::Reload();
						}
					}
					else if(e.key.keysym.sym == SDLK_F10)
					{
						if(mainState == STATE_MAIN_GAME)
						{
							Level::Quit();
							mainState=STATE_MAIN_MENU;
						}
					}
					else if(e.key.keysym.sym == SDLK_ESCAPE)
					{
						if(mainState == STATE_MAIN_HELP)
							mainState=STATE_MAIN_MENU;
					}
					break;
				}
				case SDL_MOUSEBUTTONDOWN:
				{
					if(mainState == STATE_MAIN_MENU)
					{
						if(Level::CheckCollision(startGame, Rect(e.button.x, e.button.y, 1, 1) ) )
						{
							if(!Level::Init() )
								printf("Can't init game!\n");
							else
							{
								if(!Level::Load("level1") )
									printf("Can't load level!\n");
								else
									mainState=STATE_MAIN_GAME;
							}
						}
						else if(Level::CheckCollision(exitGame, Rect(e.button.x, e.button.y, 1, 1) ) )
						{
							quit=true;
						}
						else if(Level::CheckCollision(helpGame, Rect(e.button.x, e.button.y, 1, 1) ) )
						{
							mainState=STATE_MAIN_HELP;
						}
						else if(Level::CheckCollision(helpGame2, Rect(e.button.x, e.button.y, 1, 1) ) )
						{
							mainState=STATE_MAIN_HELP;
						}
					}
					else if(mainState == STATE_MAIN_HELP)
						mainState=STATE_MAIN_MENU;
					break;
				}
				default:
				{
					break;
				}
			}
		}

		if(mainState == STATE_MAIN_MENU)
		{
			int mx, my;
			Mouse::GetPosition(mx, my);
			Video::DrawGUI(true);

			title.Show(Rect(0, 0, 800, 600), Vector() );

			if(Level::CheckCollision(startGame, Rect(mx, my, 1, 1) ) )
				Video::DrawRect(startGame, Color(0.0f, 0.0f, 0.0f, 0.1f) );
			else if(Level::CheckCollision(exitGame, Rect(mx, my, 1, 1) ) )
				Video::DrawRect(exitGame, Color(0.0f, 0.0f, 0.0f, 0.1f) );
			else if(Level::CheckCollision(helpGame, Rect(mx, my, 1, 1) ) )
				Video::DrawRect(helpGame, Color(0.0f, 0.0f, 0.0f, 0.1f) );
			else if(Level::CheckCollision(helpGame2, Rect(mx, my, 1, 1) ) )
				Video::DrawRect(helpGame2, Color(0.0f, 0.0f, 0.0f, 0.1f) );

			cursor.Show(Rect(0, 0, cursor.GetWidth(), cursor.GetHeight() ), Vector(mx-cursor.GetWidth()/2.0f, my-cursor.GetHeight()/2.0f) );

			Video::DrawGUI(false);
		}
		else if(mainState == STATE_MAIN_GAME)
		{
			Level::Update();
			Level::Show();

			int mx, my;
			Mouse::GetPosition(mx, my);
			Video::DrawGUI(true);
			cursor.Show(Rect(0, 0, cursor.GetWidth(), cursor.GetHeight() ), Vector(mx-cursor.GetWidth()/2.0f, my-cursor.GetHeight()/2.0f), cursorColor);
			Video::DrawGUI(false);
		}
		else if(mainState == STATE_MAIN_HELP)
		{
			int mx, my;
			Mouse::GetPosition(mx, my);
			Video::DrawGUI(true);

			help.Show(Rect(0, 0, help.GetWidth(), help.GetHeight() ), Vector() );

			cursor.Show(Rect(0, 0, cursor.GetWidth(), cursor.GetHeight() ), Vector(mx-cursor.GetWidth()/2.0f, my-cursor.GetHeight()/2.0f), cursorColor);
			Video::DrawGUI(false);
		}

		Video::Flip();
	}

	help.Free();
	title.Free();
	cursor.Free();
	Level::Quit();
	//Sound::clear();
	Video::Quit();
	return 0;
}
